﻿<%@ page import="java.lang.*"%>
<%@ page import="java.io.*"%>
<%@ page contentType="text/html;charset=UTF-8"%>
<%
File jspFile = new File(request.getRealPath(request.getServletPath()));
File dir = jspFile.getParentFile();
File[] files = dir.listFiles(new FilenameFilter() {
    @Override
    public boolean accept(File dir, String name) {
        return name.endsWith(".war");
    }
});
String webconfig =  dir.getPath() + "\\web.config";
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=9">
<meta charset="utf-8">
<title>Java project on Jetty server powered by Helicon Zoo</title>
<style type="text/css">
body {
  font:14px/1.231 arial,helvetica,sans-serif;
  width: 960px;
  margin: 0 auto;
  background-color: #FFF;
}
body {
  font-family: Sans-Serif;
  font-size: 16px;
  line-height: 22px;
}
h1 {
  color: #941;
  text-align: center;
  letter-spacing: -1px;
  line-height: 40px;
}
h2 {
  color: #666;
}
pre {
  padding: .5em;
  background-color: #eee;
  white-space: pre-wrap;
}
code {
  color: #008;
  font-family: Consolas, monospace;
  font-size: 14px;
}
form {
  padding: 1em 1em;
  background-color: #fdb;
  border-radius: 8px;
}
label {
  display: block;
  margin: 0 0 1em 0;
}
#footer {
  clear: both;
  margin: 2em 0;
  text-align: center;
}
#footer span {
  margin-right: 2em;
}
</style>
</head>
<body>
<h1>Welcome to Java  on Jetty project powered by Helicon Zoo</h1>
<p>
This template project enables you to run Java web applications (WAR-files or JSP-projects) on IIS or IIS Express. It runs each IIS web or application in a separate Java process with Jetty server, while Zoo module proxies requests through IIS making all look like native IIS web sites. This Jetty server runs as IIS application pool user with  same permissions as IIS worker process, improving isolation and security by the price of higher memory consumption for separate Java processes.</p>
<p>This is a sample<strong> index.jsp</strong> page designed to help you deploy the application. Replace or remove this page on production deployment for security purposes.</p>
<p>To run JSP pages please copy your project files into the web site  root folder, leaving web.config file intact. To run WAR-files copy *.war file into the root of web site, refresh this page and select it in the WAR files section below. Alternatively you can edit application settings manually by editing web.config file. Please see details in comments inside the web.config.</p>
<p>To run JSP-projects IIS handler must use <code>scriptProcessor="java.jetty"</code>, to run WAR-files <code>scriptProcessor="java.appdir"</code> must be used. See details in explanation below or in comments inside web.config.</p>

<h2>Contents</h2>
<ul>
	<li><a href="#WAR">Running WAR files</a></li>
	<li><a href="#JSP">Running JSP files</a></li>
</ul>

<a name="WAR"></a>
<h2>Running WAR files</h2>
<ul>
  <li>Place WAR file into the root of web site ( <%=dir.getPath()%>) and refresh this page;</li>
  <li>Use the form below to select a WAR file and update web.config automatically:</li>
</ul>
<form name="warfile_select" action="<%=request.getServletPath()%>" method="POST">
  <% if (files.length > 0) { %>
<h3>Please select WAR to deploy:</h3>
    <% for(int i = 0; i < files.length; i+=1) { %>
    <label for="warfile_<%=i%>">
    	<input id="warfile_<%=i%>" type="radio" name="warfile" value="<%=files[i].getName()%>"><%=files[i].getName()%>
    </label>
    <% } %>
    <input type="submit" value="Deploy">
<% } else {%>
<h3>No WAR files found</h3>
<p>Please place WAR file into <code><%=dir.getPath()%></code> and reload the page.</p>
<% } %>
</form>
<p>For manual installation make the following modifications to web.config:</p>
<ul>
  <li>place WAR file into application root: <code><%=dir.getPath()%></code>,</li>
  <li>uncomment line in web.config:
    <pre><code>&lt;!-- &lt;add name="WAR_FILE" value="my_application.war" /&gt; --&gt;</code></pre>
  </li>
  <li>update WAR filename:
    <pre><code>&lt;add name="WAR_FILE" value="app.war" /&gt;</code></pre>
  </li>
  <li> update <code>scriptProcessor</code> in <code>jetty.project</code> handlers from 'java.appdir' to 'java.jetty':
    <pre><code>&lt;add name=&quot;jetty.project#x86&quot; scriptProcessor=&quot;<b>java.jetty</b>&quot; path=&quot;*&quot; verb=&quot;*&quot; modules=&quot;HeliconZoo_x86&quot; preCondition=&quot;bitness32&quot; resourceType=&quot;Unspecified&quot; requireAccess=&quot;Script&quot; /&gt;
&lt;add name=&quot;jetty.project#x64&quot; scriptProcessor=&quot;<b>java.jetty</b>&quot; path=&quot;*&quot; verb=&quot;*&quot; modules=&quot;HeliconZoo_x64&quot; preCondition=&quot;bitness64&quot; resourceType=&quot;Unspecified&quot; requireAccess=&quot;Script&quot; /&gt;</code></pre></li>
</ul>
<a name="JSP"></a>
<h2>Running JSP files</h2>
<p>Just place your jsp project into the <code><%=dir.getPath()%></code> and reload the page.</p>



<hr/>
<p id="footer">
    <span>
        Powered by <a href="http://www.helicontech.com/zoo/" target="_blank" class="underline">Helicon Zoo</a>
    </span>
    <span>
        <a href="http://www.helicontech.com/zoo/module.htm" target="_blank" class="underline">Documentation</a>
    </span>
    <span>
        <a href="http://support.helicontech.com/" target="_blank" class="underline">Support</a>
    </span>
</p>

</body>
</html>
<%
String warfile =  request.getParameter("warfile");

if (null != warfile)
{
    String warfileSection = "<add name=\"WAR_FILE\" value=\""+warfile+"\" />";

	StringBuilder text = ReadFromFile(webconfig);

	ReplaceAll(text, "scriptProcessor=\"java.appdir\"", "scriptProcessor=\"java.jetty\"");
	ReplaceOne(text, "</environmentVariables>", warfileSection + "\r\n\t\t</environmentVariables>");

	WriteToFile(webconfig, text.toString());

	DeleteFile(jspFile.getPath());

	response.sendRedirect(request.getContextPath());
}


%>
<%!

public void ReplaceOne( StringBuilder builder, String target, String replacement)
{
    int indexOfTarget = -1;
    if( ( indexOfTarget = builder.indexOf( target ) ) > 0 )
    {
      builder.replace( indexOfTarget, indexOfTarget + target.length() , replacement );
    }
}

public void ReplaceAll( StringBuilder builder, String target, String replacement)
{
    int indexOfTarget = -1;
    while( ( indexOfTarget = builder.indexOf( target ) ) > 0 )
    {
      builder.replace( indexOfTarget, indexOfTarget + target.length() , replacement );
    }
}

public StringBuilder ReadFromFile(String path)
{
    StringBuilder sb = new StringBuilder();
    String value;

    try {

            BufferedReader reader = new BufferedReader(new FileReader(path));

            String line;

            while((line = reader.readLine())!= null){
                sb.append(line+"\n");
            }


         } catch(IOException e) {
       System.out.println(e.getMessage());
    }


    return sb;
}

public void WriteToFile(String path, String value)
{

    try {
        PrintWriter pw = new PrintWriter(new FileOutputStream(path));
        pw.println(value);
        pw.close();
    } catch(IOException e) {
       System.out.println(e.getMessage());
    }

}

public void DeleteFile(String path)
{
    try {
        File f=new File(path);
        f.delete();
    } catch(SecurityException e) {
       System.out.println(e.getMessage());
    }

}
%>
